/** Kerrighed Kernel Hooks **/

#ifndef __FAF_H__
#define __FAF_H__

extern off_t (*kh_faf_lseek)(struct file *file, off_t offset,
			     unsigned int origin) ;
extern long (*kh_faf_llseek)(struct file *file, unsigned long offset_high,
			     unsigned long offset_low, loff_t * result,
			     unsigned int origin) ;
extern ssize_t (*kh_faf_read)(struct file *file, char * buf, size_t count) ;
extern ssize_t (*kh_faf_write)(struct file *file, const char * buf,
			       size_t count) ;
extern long (*kh_faf_fcntl)(struct file *file, unsigned int cmd,
			    unsigned long arg) ;
extern long (*kh_faf_fcntl64)(struct file *file, unsigned int cmd,
			      unsigned long arg) ;
extern long (*kh_faf_ioctl)(struct file *file, unsigned int cmd,
			    unsigned long arg) ;
extern long (*kh_faf_fstat)(struct file *file, struct kstat *stat) ;
extern long (*kh_faf_fsync)(struct file *file) ;
extern long (*kh_faf_flock)(struct file *file, unsigned int cmd) ;
extern char *(*kh_faf_d_path)(struct file *file, char *buffer, int size);
extern void (*kh_faf_srv_close)(struct file *file);


struct sockaddr;
struct msghdr;

extern long (*kh_faf_bind)(struct file * file, struct sockaddr __user *umyaddr,
			   int addrlen);
extern long (*kh_faf_connect)(struct file * file,
			      struct sockaddr __user *uservaddr, int addrlen);
extern long (*kh_faf_listen)(struct file * file, int backlog);
extern long (*kh_faf_accept)(struct file * file,
			     struct sockaddr __user *upeer_sockaddr,
			     int __user *upeer_addrlen);
extern long (*kh_faf_getsockname)(struct file * file,
				  struct sockaddr __user *usockaddr,
				  int __user *usockaddr_len);
extern long (*kh_faf_getpeername)(struct file * file,
				  struct sockaddr __user *usockaddr,
				  int __user *usockaddr_len);
extern long (*kh_faf_send)(struct file * file, void __user * buff, size_t len,
			   unsigned flags);
extern long (*kh_faf_sendto)(struct file * file, void __user * buff,
			     size_t len, unsigned flags,
			     struct sockaddr __user *addr, int addr_len);
extern long (*kh_faf_recv)(struct file * file, void __user * ubuf, size_t size,
			   unsigned flags);
extern long (*kh_faf_recvfrom)(struct file * file, void __user * ubuf,
			       size_t size, unsigned flags,
			       struct sockaddr __user *addr,
			       int __user *addr_len);
extern long (*kh_faf_shutdown)(struct file * file, int how);
extern long (*kh_faf_setsockopt)(struct file * file, int level, int optname,
				 char __user *optval, int optlen);
extern long (*kh_faf_getsockopt)(struct file * file, int level, int optname,
				 char __user *optval, int __user *optlen);
extern long (*kh_faf_sendmsg)(struct file * file, struct msghdr __user *msg,
			      unsigned flags);
extern long (*kh_faf_recvmsg)(struct file * file, struct msghdr __user *msg,
			      unsigned int flags);

#endif // __FAF_H__
