#ifndef __KKRG_MSG__
#define __KKRG_MSG__

#include <kerrighed/ipc.h>
#include <linux/ipc_util.h>

/** Kerrighed Hooks **/
extern struct msg_queue * (*kh_ipcmsg_lock) (struct ipc_namespace *ns, 
					     int id);
extern void (*kh_ipcmsg_unlock) (struct msg_queue *msq);

extern int (*kh_ipcmsg_newque) (struct ipc_namespace *ns, 
				struct msg_queue *msq);

extern void (*kh_ipcmsg_freeque) (struct ipc_namespace *ns, 
				  struct msg_queue *msq,
				  int id);

extern long (*kh_ipcmsg_rmid) (int msqid);

extern long (*kh_ipc_msgsnd) (int msqid, long mtype, void __user *mtext,
			      size_t msgsz, int msgflg, struct ipc_namespace *ns,
			      pid_t tgid);

extern long (*kh_ipc_msgrcv) (int msqid, long *pmtype, void __user *mtext,
			      size_t msgsz, long msgtyp, int msgflg,
			      struct ipc_namespace *ns, pid_t tgid);

#define msg_ids(ns)	(*((ns)->ids[IPC_MSG_IDS]))

static inline struct msg_queue* local_msg_lock(struct ipc_namespace *ns,
                                                   int id)
{
	return (struct msg_queue*)ipc_lock(&msg_ids(ns),id);
}

static inline void local_msg_unlock(struct msg_queue *msq)
{
	ipc_unlock(&(msq)->q_perm);
}

static inline struct msg_queue* msg_lock(struct ipc_namespace *ns, int id)
{
	if (kh_ipcmsg_lock)
		return kh_ipcmsg_lock(ns, id);
	else
		return local_msg_lock(ns, id);
}

static inline void msg_unlock(struct msg_queue *msq)
{
	if (kh_ipcmsg_unlock)
		kh_ipcmsg_unlock(msq);
	else
		local_msg_unlock(msq);
}

long __do_msgsnd(int msqid, long mtype, void __user *mtext,
		 size_t msgsz, int msgflg, struct ipc_namespace *ns,
		 pid_t tgid);

long __do_msgrcv(int msqid, long *pmtype, void __user *mtext,
		 size_t msgsz, long msgtyp, int msgflg,
		 struct ipc_namespace *ns, pid_t tgid);

void __freeque(struct ipc_namespace *ns, struct msg_queue *msq, int id);

#endif // __KKRG_MSG__
